#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
long long a, v, n;
int num;
long long sum;
long long ans=0;
void solve(){
    ans=0;
    if(a==v){ans++;}
    for(int i=0; i<n-1; ++i)
    {
        while(a!=0)
        {
            num = a%10;
            sum+=num*num;
            a/=10;
        }

        if(sum==v){ans++;}
        a = sum;
        sum=0;
    }
    cout << 0 << "\n";
}
int main() {
ios_base::sync_with_stdio(false);
cin.tie(NULL);
int t;
cin >> t;
for(int i=0; i<t; ++i)
{
    cin >> a >> v >> n;
    solve();
}
return 0;
}
